#
# spec file for package OpenOffice_org-ure (Version 3.1.0.1)
#
# Copyright (c) 2009 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           OpenOffice_org-ure
Version:        3.1.1.1
Release:        1.4.moblin2
%define         ooo_build_version 3.1.1.1
%define         piece ure
#!BuildIgnore:  OpenOffice_org
BuildRequires:  OpenOffice_org-bootstrap = %version
BuildRequires:  ImageMagick ant ant-apache-regexp bison boost-devel ccache cups-devel curl-devel db4-devel flac-devel flex gnome-vfs2-devel gperf gtk2-devel icu java-devel krb5-devel libexif-devel mono-devel neon-devel openldap-devel pam-devel perl-Archive-Zip perl-Compress-Zlib python-devel recode unixODBC-devel unzip xml-commons-apis  zip
BuildRequires:  xorg-x11-server-devel
BuildRequires:  xorg-x11-proto-xproto
BuildRequires: xorg-x11-utils
%define	      ooo_prefix	%_libdir
%define	      ooo_home		ooo3
%define	      ooo_build_tag     ooo310-m19
License:        Artistic License; BSD 3-Clause; GPL v2 or later; LaTeX Public License (LPPL); LGPL v2.1 or later; LGPL v3 only; MOZILLA PUBLIC LICENSE (MPL/NPL); X11/MIT
Group:          Productivity/Office/Suite
AutoReqProv:    on
Summary:        OpenOffice.org UNO Runtime Environment
Url:            http://www.openoffice.org/
Source0:        %ooo_build_tag-%piece.tar.bz2
Source1:        %ooo_build_tag-sdk.tar.bz2
# prebuilt mono dlls for older distributions and ppc
Source100:      ooo-cli-prebuilt-3.1.1.tar.bz2
# necessary for SDK, http://udk.openoffice.org/common/man/spec/transparentofficecomponents.html
# FIXME: can be built using mingw32 C++ compiler
Source101:      unowinreg.dll
# FIXME: this patch is needed to build ure and sdk pieces at the same time
Patch990:       ooo-build-3.0.99.4-piece-sdk-with-ure.diff
Patch991:       ooo-build-3.0.99.4-mono-2.4-build-fix-workaround.diff

Patch1001: startup-strace.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-build
ExclusiveArch:  %ix86 x86_64 ppc
Requires: strace

%description
UNO is the basic technology used by OpenOffice.org. It allows to
integrate modules written in various programming languages.



%package -n OpenOffice_org-mono
License:        LGPL v3 only
Summary:        Mono UNO Bridge for OpenOffice.org
Group:          Productivity/Office/Suite
Requires:       mono-core
Requires:       %name = %version

%description -n OpenOffice_org-mono
The Mono/UNO binding allows a Mono application to access the complete
set of APIs exposed by OpenOffice.org via UNO. A trivial example
use-case might be a small mono application to create a spreadsheet,
populate it with data, charts, formatting, then save that in Excel
format.

Currently the use of Mono for add-ins & scripting inside OO.o itself is
not supported.



%package -n OpenOffice_org-pyuno
License:        LGPL v3 only
Summary:        Python UNO Bridge for OpenOffice.org
Group:          Productivity/Office/Suite
Provides:       OpenOffice_org:%ooo_prefix/%ooo_home/program/pyuno.so
Requires:       %name = %version

%description -n OpenOffice_org-pyuno
The Python-UNO bridge allows to use the standard OpenOffice.org API
from the well known Python scripting language. It can be used to
develop UNO components in python, thus python UNO components may be run
within the OpenOffice.org process and can be called from Java, C++ or
the built in StarBasic scripting language. You can create and invoke
scripts with the office scripting framework (OOo 2.0 and later) with
it. For example, it is used for the mail merge functionality.

You can find the more information at
http://udk.openoffice.org/python/python-bridge.html



%package devel
Requires:       %name = %version
Requires:       OpenOffice_org-mono = %version
Requires:       OpenOffice_org-pyuno = %version
Requires:       OpenOffice_org-bootstrap = %version
Provides:       OpenOffice_org-sdk = %version
Obsoletes:      OpenOffice_org-sdk <= %version
License:        Artistic License; BSD 3-Clause; GPL v2 or later; LaTeX Public License (LPPL); LGPL v2.1 or later; LGPL v3 only; MOZILLA PUBLIC LICENSE (MPL/NPL); X11/MIT
Summary:        OpenOffice.org URE Development
Group:          Productivity/Office/Suite
AutoReqProv:    off

%description devel
This package allows developement based on the OpenOffice.org UNO
runtime environment API.



%package devel-doc
Requires:       %name-devel = %version
Provides:       OpenOffice_org-sdk-doc = %version
Obsoletes:      OpenOffice_org-sdk-doc <= %version
License:        Artistic License; BSD 3-Clause; GPL v2 or later; LaTeX Public License (LPPL); LGPL v2.1 or later; LGPL v3 only; MOZILLA PUBLIC LICENSE (MPL/NPL); X11/MIT
Summary:        OpenOffice.org URE Development
Group:          Productivity/Office/Suite
AutoReqProv:    off

%description devel-doc
This package allows developement based on the OpenOffice.org UNO
runtime environment API.



%prep
%setup -q -b1 -n %ooo_build_tag-%piece

#%patch1001 -p1
mv ../%ooo_build_tag-sdk/* .
# prebuilt stuff
mkdir -p external/cli
tar -xjf %{S:100} -C external/cli
cp %{S:101} odk/source/unowinreg/win
# FIXME: create fake prj stuff to make build happy
mkdir -p external/prj
touch external/prj/build.lst
touch external/prj/d.lst
# hotfixes
mkdir -p ooo-build/hotfixes
cp %{P:990} ooo-build/hotfixes
cp %{P:991} ooo-build/hotfixes

%build
# setup env.
OPTFLAGS=`echo $CFLAGS|sed -e 's/-Os/-O2/g'`
export CFLAGS=$OPTFLAGS
export OO_INSTDIR=%{_libdir}/%ooo_home
export OO_TOOLSDIR=$OO_INSTDIR/ooo-build/bin
export VERBOSE=1
export EXTRA_BUILD_FLAGS=%{?jobs:-P%jobs}
export EXTRA_DMAKE_FLAGS="%{?jobs:-- -P%jobs}"
$OO_TOOLSDIR/piece/build-generic %piece %ooo_build_tag || $OO_TOOLSDIR/piece/build-generic %piece %ooo_build_tag || $OO_TOOLSDIR/piece/build-generic %piece %ooo_build_tag

%install
# setup env.
export OO_INSTDIR=%{_libdir}/%ooo_home
export OO_TOOLSDIR=$OO_INSTDIR/ooo-build/bin
export DESTDIR=$RPM_BUILD_ROOT
# install SDK first because it removes solver
$OO_TOOLSDIR/piece/install-generic sdk    %ooo_build_tag
$OO_TOOLSDIR/piece/install-generic %piece %ooo_build_tag
# bin the SDK-related zip files from solver; they were installed together with URE
find $RPM_BUILD_ROOT%ooo_prefix/%ooo_home/solver -name "*.zip" -exec rm -f {} \;
%ifarch %ix86
# helper script to create compat link needed to run upstream extensions (bnc#458952)
cat << EOF > $RPM_BUILD_ROOT%ooo_prefix/%ooo_home/ure/bin/create-libstlport-compat-links
#!/bin/sh
# helper script to create compat link needed to run upstream extensions (bnc#458952)
if ! test -L %_libdir/libstlport_gcc.so -a -r %_libdir/libstlport_gcc.so ; then
    lib_name=\`ls %_libdir/libstlport_gcc.so.4* | tail -n 1\`
    lib_name=\`basename \$lib_name\`
    if test -r %_libdir/\$lib_name ; then
	rm -f %_libdir/libstlport_gcc.so
	ln -sf \$lib_name %_libdir/libstlport_gcc.so
    fi
fi
EOF
chmod 755 $RPM_BUILD_ROOT%ooo_prefix/%ooo_home/ure/bin/create-libstlport-compat-links
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%pre
# crazy hack for the ugly extensions
if test $1 -gt 1 ; then
    if test -n "`find %{_libdir}/%ooo_home/share/uno_packages/cache -name LanguageTool-0.9.3.oxt`" ; then
	# try to remove the LangTool extension by the older URE; it can't be
	# removed with OOo-3.1 and higher
	echo "Unregistering the LangTool extension from OpenOffice.org..."
	unopkg remove --shared org.openoffice.languagetool.oxt || true;
	# clear disk cache
	unopkg list --shared > /dev/null 2>&1 || true;
    fi
fi

%post
/sbin/ldconfig
# clean the UNO cache if there is a broken extension
unopkg-regenerate-cache %{_libdir}/%ooo_home LanguageTool-0.9.3.oxt || true

%postun
/sbin/ldconfig
%ifarch %ix86
if test $1 = 0 ; then
    # OOo is removed => remove the link as well if it is not created by stlport-devel package (bnc#458952)
    if test -L %_libdir/libstlport_gcc.so -a ! -r %_prefix/include/stlport/ctime ; then
	rm -f %_libdir/libstlport_gcc.so
    fi
fi
%endif

%ifarch %ix86
%posttrans
# the compat link was %%ghost in old OOo-ure packages, so it might be removed also during OOo-ure update (bnc#458952)
if test -f %ooo_prefix/%ooo_home/ure/bin/javaldx ; then
    %ooo_prefix/%ooo_home/ure/bin/create-libstlport-compat-links || true;
fi
%endif


%post devel
/sbin/ldconfig

%postun devel
/sbin/ldconfig

%files -f files-%piece.txt
%defattr(-,root,root)
%ifarch %ix86
%ooo_prefix/%ooo_home/ure/bin/create-libstlport-compat-links
%endif

%files -f files-mono.txt -n OpenOffice_org-mono
%defattr(-,root,root)

%files -f files-pyuno.txt -n OpenOffice_org-pyuno
%defattr(-,root,root)
/usr/lib/ooo3/basis3.1/program/pythonloader.pyc
/usr/lib/ooo3/basis3.1/program/pythonloader.pyo
/usr/lib/ooo3/basis3.1/program/uno.pyc
/usr/lib/ooo3/basis3.1/program/uno.pyo
/usr/lib/ooo3/basis3.1/program/unohelper.pyc
/usr/lib/ooo3/basis3.1/program/unohelper.pyo

%files -f files-sdk.txt devel
%defattr(-,root,root)
%dir %ooo_prefix/%ooo_home/solver
%ooo_prefix/%ooo_home/solver/*

%files -f files-sdk-doc.txt devel-doc
%defattr(-,root,root)

%changelog
* Tue Sep  1 2009 Anas Nashif <anas.nashif@intel.com> - 3.1.1.1
- Initial import into Moblin
* Wed Aug 26 2009 pmladek@suse.cz
- updated to the milestone ooo310-m19
- updated ooo-build to version 3.1.1.1 (3.1.1-rc1)
- fixed libstlport compat symlinks handling; the %%%%ghost file conflicted
  with the libstlport_gcc4-devel package
* Tue Aug 18 2009 pmladek@suse.cz
- updated to the milestone ooo310-m18
- updated ooo-build to version 3.1.0.99.3 (3.1.1-beta3)
* Tue Aug  4 2009 pmladek@suse.cz
- updated to the milestone ooo310-m17
- updated ooo-build to version 3.1.0.99.2 (3.1.1-beta2)
* Thu Jul 23 2009 pmladek@suse.cz
- updated to the milestone ooo310-m16
- updated ooo-build to version 3.1.0.99.1 (3.1.1-beta1)
* Mon Jun 29 2009 pmladek@suse.cz
- updated to the milestone ooo310-m14
- updated ooo-build to version 3.1.0.98.2 (3.1.1-alpha2)
- added libstlport_gcc4 into Recommends; added hacks to create compat
  symlinks to improve compatibility with upstream extensions (bnc#458952)
* Wed Jun 17 2009 pmladek@suse.cz
- updated prebuilt cli dlls for PPC and SLED10
* Mon Jun 15 2009 pmladek@suse.cz
- updated to the milestone ooo310-m13
- updated ooo-build to version 3.1.0.98.1 (3.1.1-alpha1)
* Thu May 28 2009 pmladek@suse.cz
- updated ooo-build to version 3.1.0.6 (3.1-rc7 == final)
* Tue May 26 2009 pmladek@suse.cz
- updated ooo-build to version 3.1.0.5 (3.1-rc6)
* Fri May 22 2009 pmladek@suse.cz
- updated ooo-build to version 3.1.0.4 (3.1-rc5)
* Thu May 21 2009 pmladek@suse.cz
- updated ooo-build to version 3.1.0.3 (3.1-rc4)
* Tue May 19 2009 pmladek@suse.cz
- updated ooo-build to version 3.1.0.2 (3.1-rc3)
* Fri May 15 2009 pmladek@suse.cz
- updated ooo-build to version 3.1.0.1  (3.1-rc2)
* Thu May  7 2009 pmladek@suse.cz
- updated ooo-build to version 3.1.0.0  (3.1-rc1)
* Thu Apr 30 2009 pmladek@suse.cz
- updated to the milestone ooo310-m11 (3.1-rc2)
- updated ooo-build to version 3.0.99.7 (3.1-beta7)
* Fri Apr 24 2009 pmladek@suse.cz
- updated to the milestone ooo310-m10
- updated ooo-build to version 3.0.99.6 (3.1-beta6)
* Fri Apr 17 2009 pmladek@suse.cz
- updated ooo-build to version 3.0.99.5 (3.1-beta5)
- added the SDK stuff (bnc#428403):
  * added sdk source tarball
  * added prebuilt unowinreg.dll
  * fixed build of the SDK stuff together with the ure stuff
  * added provides and obsoletes of OpenOffice_org-sdk to
    OpenOffice_org-ure-devel
  * created new subpackage ure-devel-doc; it provides and obsoletes the older
    OpenOffice_org-sdk-doc
* Wed Apr 15 2009 pmladek@suse.cz
- added a workaround to fix build with mono-2.4 (bnc#495112)
* Wed Apr  8 2009 pmladek@suse.cz
- updated to the milestone ooo310-m9
- updated ooo-build to version 3.0.99.4 (3.1-beta4)
* Fri Mar 27 2009 pmladek@suse.cz
- updated to the milestone ooo310-m7
- updated ooo-build to version 3.0.99.3 (3.1-beta3)
- added hacks to remove the broken LanguageTool-0.9.3.oxt
* Fri Mar 20 2009 pmladek@suse.cz
- updated to the milestone ooo310-m6
- updated ooo-build to version 3.0.99.2 (3.1-beta2)
* Tue Mar 10 2009 pmladek@suse.cz
- updated to the milestone ooo310-m4
- updated ooo-build to version 3.0.99.1 (3.1-beta1)
* Fri Feb 20 2009 pmladek@suse.cz
- updated ooo-build to version 3.0.0.16.1
* Fri Feb  6 2009 pmladek@suse.cz
- updated ooo-build to version 3.0.0.15
* Fri Jan 23 2009 pmladek@suse.cz
- updated ooo-build to version 3.0.0.13
- added ExclusiveArch: %%%%%%%%ix86 x86_64 ppc (bnc#465252)
* Fri Jan  9 2009 pmladek@suse.cz
- updated ooo-build to version 3.0.0.11
* Fri Dec  5 2008 pmladek@suse.cz
- updated ooo-build to version 3.0.0.10
* Thu Nov 27 2008 pmladek@suse.cz
- enabled mono on PPC; added prebuilt cli dlls for PPC and older
  distributions (bnc#449047, bnc#449711)
* Fri Nov 21 2008 pmladek@suse.cz
- updated ooo-build to version 3.0.0.9
- added OpenOffice_org-mono to requires of the devel package; the devel
  package is common for all subpackages
* Fri Nov  7 2008 pmladek@suse.cz
- updated ooo-build to version 3.0.0.8
* Mon Oct 27 2008 pmladek@suse.cz
- updated ooo-build to version 3.0.0.7
- added OpenOffice_org-pyuno to requires of the devel package; the devel
  package is common for all subpackages
* Fri Oct 10 2008 pmladek@suse.cz
- updated to the milestone ooo300-m9 (3.0rc4)
- updated ooo-build to version 3.0.0.6
- added BuildIgnore OpenOffice_org to avoid cyclic build dependency
* Sat Sep 27 2008 pmladek@suse.cz
- updated to the milestone ooo300-m7 (3.0rc2)
- updated ooo-build to version 3.0.0.5
* Thu Sep 11 2008 pmladek@suse.cz
- split from the main OpenOffice_org package, version 3.0.0.4
